#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

char * extract_filename (char *pathname, char *filename)
{
	//
	// Funzione utilizzata per estrarre
	// il filename dal pathname
	//
	int p1=0;
	int x;
	for (x=strlen(pathname)-1;x>=0;x--)
	{
		if (pathname[x]=='/' && !p1)
		{
			p1=x+1;
			break;
		}

	}
	strcpy (filename,pathname+p1);

	return (filename);	
}

int MoveSavedDn ()
{
	//
	// Ripristina Gioco Precedente (UnDo)
	//
	if (CORSAVED<=1) return (0);

	CORSAVED--;

	sprintf (BUFF,"%s/%s.%03d",DIR_SAVED,"game",CORSAVED);

	Clear_Comments();
	ResetGame();
	
	CaricaGame (BUFF);

	Redisplay(0);

	sprintf (STEP,"%d/%d",CORSAVED,MAXSAVED);
	CambiaTesto(CmdStep,STEP);

	return (0);
}

int MoveSavedTop ()
{
	//
	// Ripristina Gioco Iniziale (UnDo)
	//
	if (CORSAVED<=1) return (0);

	CORSAVED=2;

	MoveSavedDn ();

	return (0);
}

int MoveSavedUp ()
{
	//
	// Ripristina Gioco Successivo (Do)
	//
	if (CORSAVED==MAXSAVED) return (0);

	CORSAVED++;

	sprintf (BUFF,"%s/%s.%03d",DIR_SAVED,"game",CORSAVED);

	Clear_Comments();
	ResetGame();

	CaricaGame (BUFF);

	Redisplay(0);

	sprintf (STEP,"%d/%d",CORSAVED,MAXSAVED);
	CambiaTesto(CmdStep,STEP);

	return (0);
}

int MoveSavedBottom ()
{
	//
	// Ripristina Gioco Finale (Do)
	//
	if (CORSAVED==MAXSAVED) return (0);

	CORSAVED=MAXSAVED-1;

	MoveSavedUp ();

	return (0);
}

int DoSaved ()
{
	// 
	// Salva GiocoCorrente
	//
	ListCmdItemInfo *Item=NULL;
	int x,y;
	FILE *out, *fopen();
	
	
	sprintf (BUFF,"%s/%s.%03d",DIR_SAVED,"game",CORSAVED+1);
	out = fopen(BUFF, "w");
	if (!out)
	{
		char err[64];
		sprintf (
			err,
			gettext("Error opening %s"),BUFF);
		Alert (
			err,
			gettext("Ok"),NULL);
		return (1);
	}

	// Salva i Commenti
	Item=ViewComment->PrimoItem;
	while (Item)
	{
		if (strcmp("-- Break --",Item->Buff))
		{
			fprintf (out,"#%s\n",Item->Buff);
		}
		Item=Item->Next;
	}


	// Salva Table
	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			//
			if (IsCandi (y,x))
				fprintf (out,"c");
			else if (!IsFixed (y,x))
				fprintf (out,"u");
			fprintf (out,"%s ",GetCandidati(y,x));
		}
		fprintf (out,"\n");
	}
	fclose (out);
	CORSAVED++;
	MAXSAVED=CORSAVED;

	sprintf (STEP,"%d/%d",CORSAVED,MAXSAVED);
	CambiaTesto(CmdStep,STEP);
	

	return (0);
}

int CaricaGame (char *filename)
{
//
// Carica da file
//
	FILE *in, *fopen();

	short int tipo=0;	// 0 == Sconosciuto
				// 1 == sdk format 123...789
				// 2 == ss  format 123|...|123
				// 3 == sdx format 12 3 u4 56 u7
				// 4 == sdm format 123000789000456...

	char numero;
	int y,x;
	int k;
	int mc,mf; 		// Warning CANDI_MSK FIXED_MSK
	int cn;			// count numbers in same cell

	in = fopen(filename, "r");
	//in = fopen("/usr/local/share/xsudoky/saved/game.001", "r");
	if (!in)
	{
		sprintf (BUFF,gettext("Error opening %s"),filename);
		Alert (BUFF,gettext("Ok"),NULL);
		return (1);
	}


	VUOTI=(SUD_TAB * SUD_TAB);
	y=0;x=0;mc=0;mf=0;cn=0;
	while (!feof(in) && y<SUD_TAB)
	{
		do
		{
			if (fgets(BUFF, sizeof(BUFF), in)!=NULL)
			//TODO RTrim
			BUFF[strlen(BUFF)-1]='\0';

			if (BUFF[0]=='#')
				AddItemListCmd (ViewComment, LIST_BOX, BUFF+1,NULL);

		} while (BUFF[0]=='#');

		if (strlen(BUFF)==SUD_TAB) 
			tipo=1;
		else if (strlen(BUFF)==SUD_TAB+2)
			tipo=2;
		else if (strlen(BUFF)==(SUD_TAB * SUD_TAB))
			tipo=4;
		else
			tipo=3;

		for (k=0;k<strlen(BUFF);k++)
		{
			numero=tolower(BUFF[k]);
			if (numero=='c')
			{
				mc=CANDI_MSK;
			}
			if (numero=='u')
			{
				mf=FIXED_MSK;
			}
			if (numero =='x' || numero =='0' || numero=='.')
			{
				// Set All candi with mask
				SUD_BUF[y][x]= 0x5ff; 
				if (tipo!=3) {x++;mc=0;mf=0;cn=0;}
			}
			if (numero==' ' || numero ==']' || numero =='}')
			{
				x++;mc=0;mf=0;cn=0;
			}
			if (isdigit(numero) && (numero!='0'))
			{
				AddCandidato(&SUD_BUF[y][x],numero-'0');
				cn++;
				if (tipo==3)
				{
					if (!mf && !mc && cn == 1)
						SetFlagCandidato (&SUD_BUF[y][x],FIXED_MSK);
					if (!mf && !mc && cn > 1)
					{
						if (!IsCandi(y,x))
							SetFlagCandidato (&SUD_BUF[y][x],CANDI_MSK);
						if (IsFixed(y,x))
							UnsetFlagCandidato (&SUD_BUF[y][x], FIXED_MSK);
							
					}
					if (mc) 
						SetFlagCandidato (&SUD_BUF[y][x],mc);
					else 
						VUOTI--;
				}
				else
				{
					SetFlagCandidato (&SUD_BUF[y][x],FIXED_MSK);
					x++; mc=0;mf=0;cn=0;
					VUOTI--;
				}
			}
			if (x>SUD_TAB)
			{
				Alert (
					gettext("Invalid Puzzle"),
					gettext("Ok"),NULL);
				ResetGame();
				return (1);

			}
		}
		if (SUD_BUF[y][0])
		{
			y++;x=0;mc=0;mf=0;cn=0;
		}
	}

	//
	fclose (in);
	//
	return (0);
}

int SudokySalva ()
{
	int y,x;
	char *filename=FullPath("games/nuovo");
	FILE *out, *fopen();
	

	out = fopen(filename, "w");
	if (!out)
	{
		char err[64];
		sprintf (
			err,
			gettext("Error opening %s"),BUFF);
		Alert (
			err,
			gettext("Ok"),NULL);
		return (1);
	}

	// Salva Table 
	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			fprintf (out,"[");
			if (IsCandi (y,x))
				fprintf (out,"c");
			fprintf (out,"%s]",GetCandidati(y,x));
		}
		fprintf (out,"\n");
	}
	fclose (out);
	
	Alert (
		gettext("Game Saved"),
		gettext("Ok"),NULL);

	return (0);
}

